////////////////////////////////////////
///////////                //////////////
//////////       目录      /////////////
//////////                 /////////////
////////////////////////////////////////
function ContentsChecker() {
    
    var content = document.querySelector(".content");

    this.check = function () {
        if (
            ((content.innerText || "").length > 3060 &&
                content.querySelectorAll("h2").length > 1) ||
            content.querySelectorAll("h2,h3").length >= 5
        ) {
            var resTitles = getNewsTitles();
            rm.sendMessage({
                name: "onGetNewsTitles",
                titles: resTitles.titles,
                current: resTitles.current,
            });
        }
    };

    rm.onReceiveMessage("requestNewsSubTitle", function (data, callback) {
        callback(getNewsTitles());
    });

    rm.onReceiveMessage("scrollToNewsSubTitle", function (data, callback) {
        var titles = content.querySelectorAll("h2,h3");
        var dom = titles[data.index];
        var rect = dom.getBoundingClientRect();
        var to = rect.top - document.body.getBoundingClientRect().top - 80;
        try {
            window.scrollTo({ top: to, behavior: "smooth" });
        } catch (error) {
            window.scrollTo(0, to);
        }
    });

    function getNewsTitles() {
        var titles = content.querySelectorAll("h2,h3");
        var resTitles = [];
        var tempDiv = document.createElement("div");
        for (var index = 0; index < titles.length; index++) {
            var title = titles[index];
            tempDiv.innerHTML = title.innerHTML;
            var exclude = true
            while (exclude) {
                if (typeof exclude === "object")
                    tempDiv.removeChild(exclude);
                exclude = tempDiv.querySelector(".comment-quote-mark")
            }
            var type = title.tagName.toLowerCase();
            resTitles.push({
                title: tempDiv.innerText, //(type === "h3" ?  "• ":"") +
                type: type,
                top:
                    rm.getEnv().appver > 8.08
                        ? parseInt(
                            title.getBoundingClientRect().top -
                            document.body.getBoundingClientRect().top
                        )
                        : -1,
            });
        }
        var scrollHeight = window.scrollY;
        var windowHeight = window.innerHeight || window.clientHeight;
        var firstUnreachedTitle = -1;
        for (var i = 0; i < resTitles.length; i++) {
            if (
                firstUnreachedTitle == -1 &&
                resTitles[i].top - scrollHeight > windowHeight - 80
            ) {
                firstUnreachedTitle = i;
                break;
            }
        }
        if (firstUnreachedTitle == -1) {
            firstUnreachedTitle = resTitles.length;
        }
        return { titles: resTitles, current: firstUnreachedTitle - 1 };
    }
}
var contentsChecker = new ContentsChecker();