////////////////////////////////////////
///////////                //////////////
//////////     关注按钮     /////////////
//////////                 /////////////
////////////////////////////////////////

function FollowBtn(ele) {
    var that = this;
    var STATE = {
        UNFOLLOW: 0,
        FOLLOWING: 1,
        FOLLOWED: 2,
        UNFOLLOWING: 3,
    };
    this.userAccountId = 0;
    this.currentState = 0;
    this.STATE = STATE;
    this.initState = function (accountId) {
        that.userAccountId = accountId;
        if (isLogin()) {
            rm.sendMessage(
                {
                    name: "app-getFollowState",
                    itaccountid: accountId,
                    userid: 0,
                },
                function (res) {
                    if (res.success) {
                        that.currentState = res.isFollowed
                            ? STATE.FOLLOWED
                            : STATE.UNFOLLOW;
                        that.setState(that.currentState);
                    } else {
                        that.setState(STATE.UNFOLLOW);
                    }
                    setFollowStateTimer = setTimeout(function () {
                        document.querySelector(".follow_btn").classList.add("inited");
                    }, 200);
                }
            );
        } else {
            that.setState(STATE.UNFOLLOW);
        }
    };
    this.setState = function (state) {
        Object.values(STATE).forEach(function (value) {
            ele.classList.remove("follow_state_" + value);
        });
        ele.classList.add("follow_state_" + state);
        var stateStr = "";
        switch (state) {
            case STATE.FOLLOWING:
                stateStr = "正在添加关注";
                break;
            case STATE.UNFOLLOWING:
                stateStr = "正在取消关注";
                break;
            case STATE.FOLLOWED:
                stateStr = "点击取消关注作者";
                break;
            case STATE.UNFOLLOW:
                stateStr = "点击关注作者";
                break;
            default:
                break;
        }
        ele.setAttribute("aria-description", stateStr);
        that.currentState = state;
    };
    this.switchState = function () {
        if (
            that.currentState === STATE.FOLLOWING ||
            that.currentState === STATE.UNFOLLOWING
        ) {
            toast("操作中，请稍候");
            return;
        }
        if (that.userAccountId === 0) {
            toast("初始化中，请稍候");
            return;
        }
        rm.vibrate();
        var oldState = that.currentState;
        var newState =
            that.currentState === STATE.FOLLOWED ? STATE.UNFOLLOW : STATE.FOLLOWED;
        that.setState(
            that.currentState === STATE.FOLLOWED ? STATE.UNFOLLOWING : STATE.FOLLOWING
        );
        doAfterLogin(
            function () {
                var data = {
                    name: "app-changeFollowState",
                    itaccountid: that.userAccountId,
                    userid: 0,
                    isAddFollow: newState === STATE.FOLLOWED,
                };
                rm.sendMessage(data, function (res) {
                    if (!res.success) {
                        toast(res.message || "操作失败");
                    }
                    setTimeout(
                        function () {
                            that.setState(res.success ? newState : oldState);
                        },
                        res.success ? 200 : 0
                    );
                });
            },
            function () {
                toast("请登录后关注");
                that.setState(oldState);
            }
        );
    };
    ele.onclick = this.switchState;
}
var followBtn = new FollowBtn(document.querySelector(".follow_btn"));