////////////////////////////////////////
///////////                //////////////
//////////       投票器     /////////////
//////////                 /////////////
////////////////////////////////////////
function Vote(ele) {
    var that = this;
    this.maxCount = 0;
    this.mySelect = [];
    var myosType = "";
    var model = rm.getSystemInfoSync().systemInfo.model;
    if (rm.getEnv().platform === "Android") {
        myosType = "android";
    } else if (rm.getEnv().platform === "iOS") {
        myosType = "iphone";
    }
    this.init = function () {
        that.maxCount = 0;
        that.mySelect = [];
        var voreId = ele.id.replace("vote", "");
        var userId = (rm.getUserInfoSync().userInfo || {}).userid || 0;
        var voteInfoApi =
            "https://dyn.ithome.com/xml/vote/" +
            voreId +
            "_" +
            userId +
            ".xml?r=" +
            new Date().getTime();

        rm.request(
            {
                url: voteInfoApi,
                header: {
                    "Content-Type": "application/xml",
                },
            },
            function (res) {
                if (res.statusCode === 200) {
                    var xml = res.data;
                    var info = xml2json(xml);
                    if (!isEmpty(info.vote.voted.value)) {
                        info.vote.voted.value =
                            info.vote.voted.value.toLowerCase() === "true";
                    }
                    if (info.vote.los.value) {
                        var allowOS = info.vote.los.value;
                        if (allowOS.indexOf(myosType) === -1) {
                            info.vote.voted.value = true;
                        }
                    }
                    that.maxCount = parseInt(info.vote.votetype.value);
                    generateVoteHtml(info);
                    bindEvent(info);
                }
            }
        );
    };

    this.init();

    function generateVoteHtml(info) {
        var options = "";
        info.vote.items.item.forEach(function (option, index) {
            if (info.vote.voted.value) {
                options +=
                    '<div class="vote-result">' +
                    '<span class="vote-result-value">' +
                    (index + 1) +
                    "、" +
                    option.t.value +
                    "</span>" +
                    '<span class="vote-result-progress"><span class="vote-result-progress-inner vote-result-color-' +
                    getColorIndex(index) +
                    " vote-result-progress-inner-" +
                    option.i.value +
                    '"></span></span>' +
                    '<span class="vote-result-des">' +
                    getWidthPercent(option.c.value, info.vote.total.value) +
                    " ( " +
                    option.c.value +
                    "票 )</span>" +
                    "</div>";
            } else {
                options +=
                    '<span class="vote-option" data-id="' +
                    option.i.value +
                    '">' +
                    '<span class="vote-radio"><span>✓</span></span>' +
                    option.t.value +
                    "</span>";
            }
        });
        var html =
            '<div class="vote-container">' +
            '<span class="vote-title">' +
            info.vote.title.value +
            "</span>" +
            '<span class="vote-des">【IT之家调查】 投票人数：<span class="vote-count-num">' +
            info.vote.total.value +
            "</span></span>" +
            '<span class="vote-tip">最多可选 ' +
            info.vote.votetype.value +
            " 项" +
            (info.vote.voted.value ? "" : "<span>（投票后查看结果）</span>") +
            "</span>" +
            '<div class="vote-options ' +
            (that.maxCount > 1 ? "mulit" : "") +
            '">' +
            options +
            "</div>" +
            (info.vote.voted.value ? "" : '<span class="vote-submit">提交</span>') +
            "</div>";
        ele.innerHTML = html;
        if (info.vote.voted.value) {
            // vote-result-progress-inner-4747
            setTimeout(function () {
                info.vote.items.item.forEach(function (option, index) {
                    var dom = ele.querySelector(
                        ".vote-result-progress-inner-" + option.i.value
                    );
                    if (dom) {
                        dom.style.width = getWidthPercent(
                            option.c.value,
                            info.vote.total.value
                        );
                    }
                });
                resizerPatchfunction();
            }, 200);
        }
    }

    function bindEvent(info) {
        // 选项
        var options = ele.querySelectorAll(".vote-option");
        for (var i = 0; i < options.length; i++) {
            var option = options[i];
            option.onclick = function (e) {
                rm.vibrate();
                var node = e.currentTarget;
                if (info.vote.voted.value) {
                    return;
                }
                var optionId = parseInt(node.getAttribute("data-id"));
                if (that.mySelect.indexOf(optionId) !== -1) {
                    that.mySelect.splice(that.mySelect.indexOf(optionId), 1);
                    node.classList.remove("checked");
                } else {
                    if (that.mySelect.length >= that.maxCount && that.maxCount > 1) {
                        toast("最多可选" + that.maxCount + "项");
                    } else if (that.maxCount === 1) {
                        that.mySelect = [optionId];
                    } else {
                        that.mySelect.push(optionId);
                    }
                }
                // 更新选择
                for (var j = 0; j < options.length; j++) {
                    var thisOption = options[j];
                    var id = parseInt(thisOption.getAttribute("data-id"));
                    if (that.mySelect.indexOf(id) !== -1) {
                        thisOption.classList.add("checked");
                    } else {
                        thisOption.classList.remove("checked");
                    }
                }
            };
        }
        // 提交
        var submit = ele.querySelector(".vote-submit");
        if (submit) {
            submit.onclick = function () {
                if (that.mySelect.length === 0) {
                    toast(that.maxCount === 1 ? "请选择一个选项" : "请至少选择一个选项");
                    return;
                }
                if (that.mySelect.length > that.maxCount) {
                    toast("您最多只能选择" + that.maxCount + "个选项");
                    return;
                }
                rm.vibrate();
                doAfterLogin(function () {
                    var url = Api(
                        "https://dyn.ithome.com/api/vote.asmx/PostVote?userHash={userhash}&voteID={voteid}&items={voteitems}&os={ostype}&device={device}",
                        {
                            userhash: getUserHash(),
                            voteid: info.vote.id.value,
                            voteitems: that.mySelect.join(","),
                            ostype: myosType,
                            device: model,
                        }
                    );
                    rm.request({ url: url }, function (submitResXml) {
                        if (submitResXml.statusCode === 200 && submitResXml.data) {
                            var submitRes = xml2json(submitResXml.data);
                            if (submitRes.string.value) {
                                var resultStr = submitRes.string.value;
                                if (
                                    resultStr.indexOf("投票成功") !== -1 ||
                                    resultStr.indexOf("投过票了") !== -1
                                ) {
                                    info.vote.voted.value = true;
                                    if (resultStr.indexOf("投票成功") !== -1) {
                                        var resultTotal = parseInt(info.vote.total.value) + 1;
                                        info.vote.total.value = resultTotal + "";
                                        info.vote.items.item.forEach(function (item, index) {
                                            if (
                                                that.mySelect.indexOf(parseInt(item.c.value)) !== -1
                                            ) {
                                                item.c.value = parseInt(item.c.value) + 1 + "";
                                            }
                                        });
                                    }
                                    generateVoteHtml(info);
                                }
                                toast(resultStr);
                            } else {
                                toast("投票失败，稍后再试");
                            }
                        }
                    });
                }, "登录后才能投票哦~");
            };
        }
    }

    function getWidthPercent(count, total) {
        if (parseInt(total) === 0) {
            return "0%";
        }
        var percent = (parseInt(count) / parseInt(total)) * 100;
        var percentStr = percent.toFixed(2) + "";
        while (
            percentStr.length > 1 &&
            (percentStr[percentStr.length - 1] === "0" ||
                percentStr[percentStr.length - 1] === ".")
        ) {
            percentStr = percentStr.substring(0, percentStr.length - 1);
        }
        return percentStr + "%";
    }
    function getColorIndex(index) {
        return index % 5;
    }
}