// DOM
var header = document.querySelector(".header");
var h1 = document.querySelector("h1");
var normalMeta = document.querySelector(".normal_meta");
var itaccountMeta = document.querySelector(".itaccount_meta");
var content = document.querySelector(".content");
var footer = document.querySelector(".footer");
var editorDom = document.querySelector(".aditor");
var rewardDom = document.querySelector(".reward");
var title = document.querySelector("title");
var paragraphWidth = window.innerWidth - 2 * 16;
var themeStyle = document.querySelector("#themeColor");
var itcard = document.getElementById("itaccont-card");
var isIOS = rm.getEnv().platform === "iOS";
var isAndroid = rm.getEnv().platform === "Android";
var initWindowWidth = window.innerWidth;
function getParagraphWidth() {
  var windowWidth = window.innerWidth;
  if (isIOS && windowWidth < 80) {
    windowWidth = initWindowWidth;
  }
  return windowWidth - 2 * 16;
}
// 数据
var newsInfo = {};
var itAccountId = 0;
var newsId = 0;
var hasIframe = false;
var hasVideo = false;
var hasTable = false;
var hasPreCode = false;
var lastUserId = 0;

// 配置
var config = {};

var nativeSupportLazyLoad = "loading" in document.createElement("img");
var useNativeLazyLoad = false;
var customLazyLoadFinished = false;
var useNativeImageLoadProxy = false;
var newsInfoLoaded = false;
var times = 0;
var isShareMode = false;
var isReviewMode = false;
var needAutoLoadImage = true;
var needAutoLoadGif = false;
var fontSize = null;
var isItPreviewMode = false;
var deviceModel = "";
var redirected = false;

var needCheckLoginAutoTip = localStorage.getItem("loginTip") !== "1";

var fireworks;

setFontSize(localStorage.getItem("fontSize"));

// flag
var NewsFlag = {
  Live: 1 << 9,
  GalleryNews: 1 << 13,
  OutSiteLink: 1 << 14,
  VideoNews: 1 << 15,
};

function hasFlag(flags, flag) {
  return !!(flags & flag);
}

// 定时器，页面释放时清理掉
var setNewsInfoTimer = 0;
var refreshUserInfoTimer = 0;
var resizeTimer = 0;
var setFollowStateTimer = 0;

rm.ready(function () {
  document.documentElement.classList.remove("night");
  lastUserId = getUserId() || 0;
  if (lastUserId > 0) {
    localStorage.removeItem("loginTip");
  }
  var systemInfo = rm.getSystemInfoSync().systemInfo || {};
  deviceModel = systemInfo.model || "";
  if (systemInfo.isReviewMode) {
    document.body.classList.add("review-mode");
    isReviewMode = true;
  }
  if (isIOS) {
    if (systemInfo.systemFontWeight) {
      document.body.classList.add("font-" + systemInfo.systemFontWeight);
    }
  }

  document.body.classList.add(rm.getEnv().platform.toLowerCase());
  /// 接收文章数据
  rm.onReceiveMessage("setNewsInfo", function (data, callback) {
    console.log("原始文章数据", JSON.parse(JSON.stringify(data)));
    // var noRefMeta = document.getElementById("no-ref-meta");
    // if(isIOS){
    //   if(noRefMeta){
    //     noRefMeta.remove();
    //     window.location.reload();
    //   }
    // }
    var newConfig = data.config || {};
    if ((newConfig.userId || 0) !== lastUserId) {
      refreshUserInfoTimer = setTimeout(function () {
        rm.getUserInfo(function (res) {
          lastUserId = getUserId() || 0;
          setNewsInfo(data, callback);
          resetLoginTip(0, 0, 0)
        });
      }, 220);
    } else {
      setNewsInfo(data, callback);
    }
    function setNewsInfo(data, callback) {
      if (data.newsInfo.draftId > 0) {
        isItPreviewMode = true;
        loadItAccountPreviewInfo(data, callback);
      } else {
        isItPreviewMode = false;
        var newData = data;
        if (newConfig.apiVer === 2) {
          // 新旧接口数据转换
          var info = data.newsInfo.data;
          var itAccount = info.itAccount
            ? {
              id: info.itAccount.id,
              accountname:
                info.itAccount.accountName || info.itAccount.accountname,
              accountid:
                info.itAccount.accountId ||
                parseInt(info.itAccount.accountid || "0"),
              avatarurl: info.itAccount.avatarUrl || info.itAccount.avatarurl,
              userid: info.itAccount.userId || info.itAccount.userid,
              usernick: info.itAccount.userNick || info.itAccount.usernick,
              isinternalaccount:
                info.itAccount.isInternalAccount ||
                info.itAccount.isinternalaccount,
              closeAccountPage:
                info.itAccount.closeAccountPage ||
                info.itAccount.closeaccountpage,
              memo: info.itAccount.meMo,
            }
            : null;
          newData = {
            success: true,
            newsid: info.id,
            url: info.shareUrl,
            newssource: info.sourceName,
            newsauthor: info.author,
            image: info.images && info.images[0],
            imagelist: info.images,
            newstags: info.tags,
            newsflag: info.flag,
            itaccount: itAccount,
            reward: !!getSwitchByPosition(info.flag, 7) ? "1" : "0",
            detail: info.content,
            postdate: info.postDate,
            hitcount: info.hitCount,
            btheme: getSwitchByPosition(info.flag, 6),
            forbidcomment: getSwitchByPosition(info.flag, 5),
            commentcount: info.commentCount,
            z: info.editor,
            // 新接口通过smalltag包含广告标签判断cid
            cid: !!(info.smallTags || []).find(function (i) {
              return i.text === "广告";
            })
              ? 166
              : 0,
            ui:
              (!!itAccount && itAccount.userid > 0
                ? itAccount.userid
                : info.tougaoUserIds[0]) || 0,
          };
          Object.assign(newData, info);
          data.newsInfo = newData;
        }
        processPassedInNewsInfo(data, callback);
      }
    }
  });

  // 页面释放
  rm.onReceiveMessage("onRelease", function (data, callback) {
    redirected = false;
    clearTimeout(setNewsInfoTimer);
    clearTimeout(refreshUserInfoTimer);
    clearTimeout(resizeTimer);
    clearTimeout(setFollowStateTimer);
    var titleMark = document.querySelector(".title .comment-quote-mark");
    if (titleMark) {
      titleMark.remove();
    }
    customLazyLoadFinished = false;
    newsInfoLoaded = false;
    if (isShareMode) {
      isShareMode = false;
      document.body.classList.remove("share-mode");
    }
    window.scrollTo(0, 0);
    document
      .querySelector(".it_avatar")
      .setAttribute("src", "./imgs/avatar_default_rect.png");
    forEachNode(content, "video", function (video) {
      video.pause();
      video.src = "";
      video.load();
      video.remove();
    });
    forEachNode(content, "iframe", function (iframe) {
      iframe.src = "about:blank";
      iframe.remove();
    });
    content.innerHTML = "";
    h1.innerText = "";
    normalMeta.style.display = "none";
    itaccountMeta.style.display = "none";
    document.body.classList.add("hide");
    itcard.classList.remove("show");
    document.querySelector(".follow_btn").classList.remove("inited");
    title.innerText = "文章详情页";
    try {
      window.getSelection().removeAllRanges();
    } catch (error) { }
    audioPlayer.release()
    callback({
      success: true,
    });
  });

  function loadItAccountPreviewInfo(data, callback) {
    var apiUrl = "https://mp.ithome.com/api/news/itaccount/getdraft";
    switch (data.from) {
      case "pending":
        apiUrl = "https://mp.ithome.com/api/news/itaccount/getnews";
        break;
      case "review":
        apiUrl = "https://mp.ithome.com/api/news/itaccount/mgetnews";
        break;
    }
    var reqUrl = Api(apiUrl, {
      id: data.newsInfo.draftId,
      userhash: getUserHash(),
    });
    rm.login(function (res) {
      if (res.success) {
        rm.request({ url: reqUrl }, function (draftIndo) {
          if (draftIndo.data.success) {
            var draft = draftIndo.data.content.draft;
            data.newsInfo = {
              success: true,
              newsid: 0,
              title: draft.newstitle,
              url: "",
              newssource: "",
              newsauthor: "",
              keyword: "",
              image: "",
              newstags: [],
              newsflag: 1024,
              itaccount: {
                id: 0,
                accountname: draft.accountname,
                accountid: draft.accountid,
                avatarurl:
                  "https://img.ithome.com/mpimg/account/" +
                  draft.accountid +
                  ".jpg",
                ischeck: 0,
                userid: -1,
                usernick: "",
                isinternalaccount: true,
              },
              detail: draft.newscontent,
              postdate: draft.addtime,
              hitcount: 66666,
              btheme: false,
              forbidcomment: false,
              commentcount: 0,
              z: "刺客",
            };
            processPassedInNewsInfo(data, callback);
          } else {
            callback({
              success: false,
              message: draftIndo.data
                ? draftIndo.data.message || "加载失败"
                : "请求失败",
            });
          }
        });
      } else {
        callback({
          success: false,
          message: "登录失败",
        });
      }
    });
  }

  function processPassedInNewsInfo(data, callback) {
    newsInfo = data.newsInfo || data;
    config = data.config || {};
    config.cloud = config.cloud || {};
    themeStyle.innerText =
      ":root { --theme-color: " + (config.themeColor || "#d22222") + ";}";
    useNativeLazyLoad = nativeSupportLazyLoad && config.cloud.h5lazy === "true";
    useNativeImageLoadProxy = isIOS && !isShareMode && config.cloud.imgProxy === "true" && rm.getEnv().appver >= 8.71;
    if (useNativeImageLoadProxy)
      useNativeLazyLoad = false;

    setFontSize(config.fontSize);
    newsId = newsInfo.newsid;
    isShareMode = config.isShareMode;

    needAutoLoadImage = !(
      config.isMobiNetwork &&
      (config.loadImageOnlyWifi || config.loadImageOnlywifi)
    );
    needAutoLoadGif =
      needAutoLoadImage &&
      (!config.isMobiNetwork || config.loadGifInMobiNetwork);
    var userInfo = rm.getUserInfoSync().userInfo || {};
    var isAdmin = userInfo.ism === "true" || userInfo.isc === "true" || userInfo.userid == 47;
    var isFunNews = newsInfo.id === parseInt(config.cloud.funid || "0");

    // 标题
    if (isFunNews) {
      h1.innerHTML = getCharSpanHtml(newsInfo.title, "fu");
      document.body.classList.add("new-year");
    } else {
      h1.innerText = newsInfo.title;
      document.body.classList.remove("new-year");
    }

    document.body.classList[newsInfo.btheme ? "add" : "remove"]("grey");
    document.body.classList[newsInfo.cid === 166 ? "remove" : "add"]("noad");
    document.body.classList.remove("hide");
    // 作者\发布时间等
    var isItAccount = newsInfo.itaccount && newsInfo.itaccount.accountid > 0;
    if (isItAccount) {
      // IT号来源
      itAccountId = newsInfo.itaccount.accountid;
      normalMeta.style.display = "none";
      itaccountMeta.removeAttribute("style");
      itaccountMeta.classList[
        newsInfo.itaccount.closeAccountPage ? "add" : "remove"
      ]("close");

      document
        .querySelector(".it_avatar")
        .setAttribute("src", newsInfo.itaccount.avatarurl);
      document.querySelector(".itaccount_meta .nick").innerText =
        newsInfo.itaccount.accountname;
      var time = getDateFromString(newsInfo.postdate);
      var timeStr =
        pad(time.getFullYear(), 4) +
        "-" +
        pad(time.getMonth() + 1, 2) +
        "-" +
        pad(time.getDate(), 2) +
        " " +
        pad(time.getHours(), 2) +
        ":" +
        pad(time.getMinutes(), 2) +
        ":" +
        pad(time.getSeconds(), 2);
      document
        .querySelector(".itaccount_meta")
        .classList[newsInfo.itaccount.isinternalaccount ? "remove" : "add"](
          "it-personal"
        );
      itcard.classList[newsInfo.itaccount.isinternalaccount ? "remove" : "add"](
        "it-personal"
      );
      if (
        newsInfo.itaccount.userid > 0 &&
        newsInfo.itaccount.usernick &&
        newsInfo.itaccount.usernick !== newsInfo.itaccount.accountname
      ) {
        timeStr = newsInfo.itaccount.usernick + " · " + timeStr;
      }
      // else if(newsInfo.itaccount.userid <= 0
      //   && !isEmpty(newsInfo.newsauthor)
      //   && newsInfo.newsauthor !== newsInfo.itaccount.accountname){
      //   timeStr = newsInfo.newsauthor + " · " + timeStr;
      // }
      document.querySelector(".itaccount_meta .time").innerText = timeStr;
      followBtn.initState(newsInfo.itaccount.accountid);
      itcard
        .querySelector(".avatar img")
        .setAttribute("src", newsInfo.itaccount.avatarurl);
      itcard.querySelector(".info .nick").innerHTML =
        newsInfo.itaccount.accountname;
      itcard.querySelector(".info .abs").innerHTML =
        newsInfo.itaccount.memo || "这里本该有一条简介。";
      itcard
        .querySelector(".avatar img")
        .setAttribute("src", newsInfo.itaccount.avatarurl);
    } else {
      // IT之家来源
      itAccountId = 0;
      itaccountMeta.style.display = "none";
      itcard.classList.remove("show");
      normalMeta.removeAttribute("style");
      var time = getDateFromString(newsInfo.postdate);
      document.querySelector(".time").innerText =
        pad(time.getFullYear(), 4) +
        "-" +
        pad(time.getMonth() + 1, 2) +
        "-" +
        pad(time.getDate(), 2) +
        " " +
        pad(time.getHours(), 2) +
        ":" +
        pad(time.getMinutes(), 2) +
        ":" +
        pad(time.getSeconds(), 2);
      var from = newsInfo.newssource;
      if (!isEmpty(newsInfo.newsauthor) && newsInfo.newsauthor !== "-") {
        from += " - " + newsInfo.newsauthor + "";
      }
      document.querySelector(".author").innerText = from;
    }
    if (isAdmin && !isShareMode) {
      document.body.classList.add("admin");
      loadViewCount(newsInfo.hitcount || 0);
    }
    if (!isBirthNews()) {
      releaseFireworks()
    }
    // 正文
    parseNewsBody(newsInfo);
    // 责编\纠错
    editorDom.innerText = newsInfo.z;
    // 打赏
    if (newsInfo.reward === "1") {
      rewardDom.removeAttribute("style");
      loadRewardList();
    } else {
      rewardDom.style.display = "none";
    }
    // 浏览器标题
    title.innerText = newsInfo.title;
    newsInfoLoaded = true;
    if (isShareMode) {
      document.body.classList.add("share-mode");
      document.body.classList.remove("night");
      itcard.classList.remove("show");
    } else {
      // if(isItAccount)
      // itcard.classList.add("show");
      if (rm.getEnv().appver > 8.209) {
        document.body.classList[config.isDark ? "add" : "remove"]("night");
      }
    }
    // 音频
    audioPlayer.initPlayer(newsInfo, config)
    console.log("最终文章数据", JSON.parse(JSON.stringify(newsInfo)), config);
    setNewsInfoTimer = setTimeout(function () {
      callback({
        success: true,
        hasIframe: hasIframe,
        hasPreCode: hasPreCode,
        hasTable: hasTable,
        hasVideo: hasVideo,
      });
    }, 16);
  }

  // 设置一个初始高度
  // var screenHeight = rm.getSystemInfoSync().systemInfo.activityHeight;
  // if(screenHeight){
  //   document.body.style.height = screenHeight + "px";
  // }

  // 调试时主动索取数据
  if (window.location.href.indexOf("test=1") !== -1) {
    rm.sendMessage({
      name: "onReload",
      newsId: rm.getEnv().platform === "iOS" ? 625666 : 0,
    });
  }

  function loadRewardList() {
    var api =
      "https://dyn.ithome.com/api/newsreward/query?newsid=" +
      newsId +
      "&userhash=";
    var listDom = document.querySelector(".reward_list");
    listDom.innerHTML = "";
    var rewardTotalDom = document.querySelector(".reward_total");
    rewardTotalDom.style.display = "none";
    document.querySelector(".reward-button").onclick = function () {
      rm.vibrate();
      rm.sendMessage(
        {
          name: "requestNewsReward",
          itAccountId: itAccountId,
          newsId: newsInfo.newsid,
          authorName: newsInfo.newsauthor,
          newsUrl: getNewsUrl(newsInfo).url,
          newsImage: newsInfo.image,
        },
        function (res) {
          if (res.success) {
            loadRewardList();
          }
        }
      );
    };
    rm.request(
      {
        url: api,
      },
      function (res) {
        if (res.statusCode === 200 && res.data.success) {
          var listHtml = "";
          res.data.content.users.forEach(function (user) {
            listHtml +=
              '<img src="' +
              getAvatarAddress(user.UserId) +
              '" onerror="this.src=\'imgs/avatar_default_rect.png\'"/>';
          });
          if (res.data.content.count > res.data.content.users.length) {
            listHtml += '<img src="imgs/more_reward.png">';
          }
          listDom.innerHTML = listHtml;
          if (res.data.content.count > 0) {
            rewardTotalDom.querySelector(".reward_total_count").innerText =
              res.data.content.count;
            rewardTotalDom.removeAttribute("style");
          }
          listDom.onclick = function () {
            rm.vibrate();
            rm.sendMessage({
              name: "showRewardListDialog",
              itAccountId: itAccountId,
              newsId: newsInfo.newsid,
              authorUserId: newsInfo.ui || 0,
              rewardList: res.data.content,
            });
          };
        }
      }
    );
  }

  function getCharSpanHtml(str, className) {
    var html = "";
    for (var i = 0; i < str.length; i++) {
      html += "<span class='" + className + "'><span>" + str[i] + "</span></span>";
    }
    return html;
  }



  ////////////////////////////////////////
  ///////////                //////////////
  //////////  加载前html预处理  /////////////
  //////////                 /////////////
  ////////////////////////////////////////
  function preProcessNewsHtml(html) {
    // 移除脚本
    html = html.replace(/<script (.*?)script>/gi, "");
    html = html.replace(/<script(.*?)script>/gi, "");
    // 图片宽度处理
    var imgsReg =
      /<img[ ]*src=[ '"](.*?)[' "][ ]*w=[ '"](\d+)[' "][ ]*h=[ '"](\d+)[' "](.*?)>/gi;
    var imgReg =
      /<img[ ]*src=[ '"](.*?)[' "][ ]*w=[ '"](\d+)[' "][ ]*h=[ '"](\d+)[' "](.*?)>/i;
    var imgMatch = html.match(imgsReg);
    if (imgMatch && imgMatch.length > 0) {
      for (var i = 0; i < imgMatch.length; i++) {
        var img = imgMatch[i];
        var imgInfo = img.match(imgReg);
        if (imgInfo && imgInfo.length == 5) {
          var width = parseInt(imgInfo[2]);
          var height = parseInt(imgInfo[3]);
          var ratio = (width * 1.0) / height;
          width = Math.min(width, getParagraphWidth());
          height = parseInt(width / ratio);
          html = html.replace(
            img,
            '<img src="' +
            imgInfo[1] +
            '" width="' +
            width +
            '" height="' +
            height +
            '" w="' +
            imgInfo[2] +
            '" h="' +
            imgInfo[3] +
            '"' +
            imgInfo[4] +
            ">"
          );
        }
      }
    }
    // 图片处理
    // 1、懒加载
    var imgNormalReg = /<img[ ]*src=[ '"](.*?)[' "](.*?)>/gi;
    var imgReplaceTo =
      '<img data-orignal="' + (useNativeImageLoadProxy ? 'imgs/proxy.png' : '$1') + '" data-proxy="$1" src="imgs/transparent.png" onclick="clickImg(this)" onload="onImgLoaded(this)" onerror="onImgError(this)" $2>';
    if (needAutoLoadImage && useNativeLazyLoad && !isShareMode) {
      imgReplaceTo =
        '<img src="$1" loading="lazy" onclick="clickImg(this)" onload="onImgLoaded(this)" onerror="onImgError(this)" $2>';
    }
    html = html.replace(imgNormalReg, imgReplaceTo);
    if (needAutoLoadImage && !isShareMode) {
      if (!useNativeLazyLoad) {
        html = html.replace("data-orignal=", "src=");
        html = html.replace("data-orignal=", "src="); // 前两张图片不懒加载
      } else {
        html = html.replace('loading="lazy"', "");
        html = html.replace('loading="lazy"', ""); // 前两张图片不懒加载
      }
    }

    // fix1: mac转制版 17 强制用webP
    var isAboveMacOS14 = systemInfo.model.toLowerCase().indexOf("mac") !== -1
      && parseFloat(systemInfo.sysVer) >= 17.0
    if (isAboveMacOS14) {
      html = html.replace(/format,f_auto/g, "format,f_webp")
    }

    // 2、表情
    html = getEmotionHtml(html, "img", function (node) {
      node.setAttribute("onclick", "clickImg(this)");
    });
    return html;
  }

  function getPropHtml(data) {
    if (!isEmpty(data.detailnew)) {
      if (isLogin()) {
        return rm
          .decryptSync({ text: data.detailnew, key: "(#i@x*l9" })
          .data.replace("ithome-encrypt-news-content", "");
      }
      return '<p>文章需登录后查看，<span class="s_link" onclick="decryptNews()">点此登录</span>。</p>';
    }
    return data.detail;
  }

  function parseNewsBody(data) {
    // 获取html，可能是加密文章，需登录后解密
    var html = getPropHtml(data);
    // html预处理
    content.innerHTML = preProcessNewsHtml(html);
    // 处理投票等
    postProcessHtml(content);
    // 
    if (isBirthNews()) {
      initFireworks()
    }
  }

  function decryptNews() {
    doAfterLogin(function () {
      parseNewsBody(newsInfo);
    }, "登录后查看文章");
  }

  function checkCodeHighlight() {
    var pres = document.querySelectorAll("pre");
    hasPreCode = pres.length > 0;
    if (!hasPreCode) {
      return;
    }
    var backList = [];
    for (var i = 0; i < pres.length; i++) {
      var pre = pres[i];
      var key = "pre-code-" + i;
      backList.push({
        key: key,
        code: pre.innerText,
      });
      pre.setAttribute("data-key", key);
      pre.classList.add("prettyprint");
      pre.classList.add("linenums");
    }
    var addCopyBtn = function () {
      for (var i = 0; i < pres.length; i++) {
        var pre = pres[i];
        var key = pre.getAttribute("data-key");
        var targetCode = backList.find(function (item) {
          return item.key === key;
        });
        if (targetCode) {
          var bar = document.createElement("div");
          bar.classList.add("pre-bar");
          var barTitle = document.createElement("span");
          barTitle.classList.add("pre-bar-title");
          barTitle.innerText = "代码";
          var copyBtn = document.createElement("span");
          copyBtn.classList.add("pre-bar-copy");
          copyBtn.innerText = "[复制]";
          copyBtn.onclick = function () {
            rm.vibrate();
            rm.setClipboardData(targetCode.code, function (res) {
              toast(res.success ? "代码已复制" : "复制出错");
            });
          };
          bar.appendChild(barTitle);
          bar.appendChild(copyBtn);
          pre.insertAdjacentElement("beforebegin", bar);
        }
      }
    };

    if (typeof prettyPrint !== "undefined") {
      prettyPrint();
      addCopyBtn();
    } else {
      var script = document.createElement("script");
      script.onload = function () {
        prettyPrint();
        addCopyBtn();
      };
      script.src = "js/prettify.js";
      document.body.appendChild(script);
    }
  }

  window.decryptNews = decryptNews;

  function checkBilibili() {
    if (isShareMode) {
      return;
    }
    var iframeVideos = document.querySelectorAll('iframe[src*="bilibili"]');
    var normalLinks = document.querySelectorAll('a[href*="bilibili"]');
    if (normalLinks.length > 0 || iframeVideos.length > 0) {
      rm.canOpenURL({ url: "bilibili://space/13938355" }, function (res) {
        if (res.status === 1) {
          for (var i = 0; i < iframeVideos.length; i++) {
            (function (index) {
              var iframe = iframeVideos[index];
              var scheme = "bilibili://video/" + vid;
              var src = __parseUrl(iframe.src);
              if (src.host === "player.bilibili.com") {
                var vid = src.params.bvid || src.params.aid;
                var url = "";
                if (
                  src.params.bvid &&
                  src.params.bvid.toLowerCase().indexOf("bv") !== 0
                ) {
                  //修正BV号
                  vid = "bv" + vid;
                }
                if (!isEmpty(vid)) {
                  url = "https://www.bilibili.com/video/" + vid;
                }
                if (!isEmpty(url)) {
                  var scheme = "bilibili://video/" + vid;
                  videoParser.parse(url, function (res) {
                    if (res.success) {
                      var isIthome = res.data.author === "IT之家的哔哩哔哩视频";
                      var parent = iframe.parentNode;
                      parent.position = "relative";
                      if (isIthome) {
                        iframe.insertAdjacentHTML(
                          "afterend",
                          '<span class="open-bilibili ithome" onclick="openbilibili(\'bilibili://space/13938355\')"><span>关注IT之家B站号，看更多精彩视频</span><span class="btn">立即关注</span></span>'
                        );
                      } else {
                        iframe.insertAdjacentHTML(
                          "afterend",
                          '<span class="open-bilibili" onclick="openbilibili(\'' +
                          scheme +
                          '\')"><span>打开bilibili观看视频</span><span class="btn">打开</span></span>'
                        );
                      }
                    }
                  });
                }
              }
            })(i);
          }
          for (var i = 0; i < normalLinks.length; i++) {
            var link = normalLinks[i];
            var blUrl = getBilibiliUrlInfo(link.getAttribute("href"));
            if (!isEmpty(blUrl.scheme)) {
              link.setAttribute("data-url", blUrl.scheme);
              link.setAttribute("href", blUrl.scheme);
            }
          }
        }
      });
    }
  }

  ////////////////////////////////////////
  ///////////                //////////////
  //////////  文章加载后的处理  /////////////
  //////////                 /////////////
  ////////////////////////////////////////
  function postProcessHtml(node) {
    // 首屏图片懒加载
    // 识别gif
    var gifs = node.querySelectorAll('img[data-orignal*=".gif"]');
    for (var i = 0; i < gifs.length; i++) {
      var img = gifs[i];
      img.classList.add("gif");
    }
    if (needAutoLoadImage) {
      onWindowScroll();
    }

    checkTable(node);

    // 图片处理。不含alt的图像全部标记为装饰，无障碍跳过
    var imgs = node.querySelectorAll("img");
    for (var index = 0; index < imgs.length; index++) {
      var img = imgs[index];
      if (!img.hasAttribute("alt")) {
        img.setAttribute("alt", "");
      }
    }
    forEachNode(node, "blockquote img[w]", function (img) {
      if (img.hasAttribute("h")) {
        var width = parseInt(img.getAttribute("w"));
        var height = parseInt(img.getAttribute("h"));
        var ratio = (width * 1.0) / height;
        width = Math.min(width, getParagraphWidth() - 2 * 24);
        height = parseInt(width / ratio);
        img.setAttribute("width", width);
        img.setAttribute("height", height);
      }
    });

    // 链接点击
    anchorHelper.process(node);

    // 视频处理
    var players = node.querySelectorAll(".ithome_super_player");
    hasVideo = players.length > 0;
    if (hasVideo) {
      // var hasWeibo = false;
      for (var i = 0; i < players.length; i++) {
        var player = players[i];
        // if(!hasWeibo && (player.getAttribute("href") || '').indexOf("weibo") !== -1){
        //   hasWeibo = true;
        //   var findMeta = document.getElementById("no-ref-meta");
        //   if(!findMeta){
        //     var meta = document.createElement("meta");
        //     //  <meta name="referrer" content="no-referrer" />
        //     meta.setAttribute("name", "referrer");
        //     meta.setAttribute("content", "no-referrer");
        //     meta.id = "no-ref-meta";
        //     document.head.appendChild(meta);
        //   }
        // }
        new Player(player);
      }
    }

    // 投票处理
    var votes = node.querySelectorAll("p[id^=vote]");
    for (var i = 0; i < votes.length; i++) {
      var vote = votes[i];
      new Vote(vote);
    }

    // 代码高亮
    checkCodeHighlight();

    // 直播、圈子、图赏等非正常文章自动重定向
    try {
      var redirectLink = null;
      if (hasFlag(newsInfo.flag, NewsFlag.OutSiteLink)) {
        // 外链
        redirectLink = newsInfo.link;
      } else if (hasFlag(newsInfo.flag, NewsFlag.Live)) {
        // 直播
        redirectLink = newsInfo.link;
      }
      // else if (hasFlag(newsInfo.flag, NewsFlag.GalleryNews)) {
      //   // 图赏
      //   if (rm.getEnv().appver >= 8.6) {
      //     redirectLink = "ithome://news?id=" + newsId + "&type=gallery";//newsInfo.link;
      //   }
      // } 
      else if (hasFlag(newsInfo.flag, NewsFlag.VideoNews)) {
        // 视频
        if (rm.getEnv().appver >= (parseFloat(config.cloud.videoVer || "99999"))) {
          redirectLink = "ithome://news?id=" + newsId + "&type=video";//newsInfo.link;
        }
      }
      if (!isEmpty(redirectLink)) {
        if (!redirected) {
          redirected = true;
          rm.redirectTo({
            url: redirectLink,
          });
        }

        return;
      }
    } catch (error) { }

    // 段落评论
    quoteCommentHelper.loadData(newsInfo);

    // 点击复制
    var copyBtns = document.querySelectorAll(".click_to_copy_btn");
    var copyFunc = function (e) {
      e.preventDefault();
      rm.vibrate();
      rm.setClipboardData(e.target.innerText, function (res) {
        rm.toast({
          data: "复制成功",
          duration: 2000,
        });
      });
    };
    for (var i = 0; i < copyBtns.length; i++) {
      var btn = copyBtns[i];
      btn.onclick = copyFunc;
    }

    // bilibili视频
    hasIframe = content.querySelectorAll("iframe").length > 0;
    if (hasIframe) {
      checkBilibili();
    }

    // 目录生成
    contentsChecker.check();

    // 灰色新闻
    if (newsInfo.btheme) {
      rm.sendMessage({
        name: "changePageColorToGrey",
        reason: [],
      });
    }

    // 分享模式 全 全
    if (isShareMode) {
      dealWithShareMode();
    }

    // 点击统计
    clickFeedback();

    // 临时代码
    var isIosBelow831 =
      rm.getEnv().platform === "iOS" &&
      rm.getEnv().appver <= 8.31 &&
      parseFloat(systemInfo.sysVer) > 16.199;
    if (isIosBelow831) {
      if (localStorage && localStorage.getItem("tipForIosBelow831") !== "1") {
        localStorage.setItem("tipForIosBelow831", "1");
        rm.showModal(
          {
            title: "提示",
            content:
              "若您遇到打开文章自动滚动到底部问题，请升级最新版本（8.50+）来解决~",
            textAlign: "left",
            cancelText: "知道了",
            showCancel: true,
            confirmText: "立即升级",
          },
          function (res) {
            if (res.confirm) {
              rm.navigateTo({
                url: "http://m.ithome.com/ithome/download/",
              });
            }
          }
        );
      }
    }
  }


  ////////////////////////////////////////
  ///////////                //////////////
  //////////       图片点击    /////////////
  //////////                 /////////////
  ////////////////////////////////////////
  function clickImg(target) {
    // var target = e.target;
    if (
      target.classList.contains("emotion") ||
      target.classList.contains("ruanmei-emotion")
    ) {
      var alt = target.getAttribute("title");
      if (!isEmpty(alt)) {
        rm.toast({
          data: alt,
        });
      }
      target.classList.add("shake");
      setTimeout(function () {
        target.classList.remove("shake");
      }, 5000);
      return;
    }
    var realSrc = getRealSrc(target);
    if (realSrc && target.getAttribute("src") !== realSrc) {
      target.src = realSrc;
      target.classList.add("loading");
    } else if (checkImageProxyLoad(target)) {
      // iOS 原生代理请求，等待，不做任何处理
    } else if (!target.hasAttribute("data-noneclick")) {
      // 查看大图
      realSrc = getRealSrc(target, true);
      if (target.hasAttribute("data-highquality")) {
        realSrc = target.getAttribute("data-highquality");
      }
      var resImgs = [];
      var imgs = content.getElementsByTagName("img");
      for (var i = 0; i < imgs.length; i++) {
        var element = imgs[i];
        if (
          !element.hasAttribute("data-noneclick") &&
          element.className.indexOf("ruanmei-emotion") === -1
        ) {
          var realImgUrl = getRealSrc(element, true);
          if (element.hasAttribute("data-highquality")) {
            realImgUrl = element.getAttribute("data-highquality");
          }
          resImgs.push(removeWebpParam(realImgUrl));
        }
      }
      var params = {
        url: removeWebpParam(realSrc),
        urlThumb: target.getAttribute("data-proxy") || target.getAttribute("src"),
        anchor: target.getBoundingClientRect(),
        imgUrls: resImgs,
      };
      if (hasFlag(newsInfo.flag, NewsFlag.GalleryNews) &&
        rm.getEnv().appver >= parseFloat(config.cloud.galleryVer || "99999")) {
        // 图赏图片
        rm.navigateTo({
          url: "ithome://news?id=" + newsId + "&type=gallery&imgUrl=" + encodeURIComponent(params.url)
        })
      } else {
        // 普通图片
        rm.previewImage(params);
      }
    }
  }
  window.clickImg = clickImg;
  window.openbilibili = function (url) {
    rm.navigateTo({
      url: url,
    });
    rm.vibrate();
  };
  window.requestLogin = function () {
    closeLoginTip();
    rm.login(function (res) {
    })
  };
  ////////////////////////////////////////
  ///////////                //////////////
  //////////       滚动监听    /////////////
  //////////                 /////////////
  ////////////////////////////////////////
  var lastScrollY = -99;
  var tipBar = document.querySelector(".login-tip");
  // 引导登录
  function resetLoginTip(scrollTop, bodyHeight, windowHeight) {
    var userInfoA = rm.getUserInfoSync();
    var isLogin = userInfoA && userInfoA.success;
    if (needCheckLoginAutoTip && tipBar && !isLogin) {
      if (scrollTop > windowHeight / 3 && !tipBar.classList.contains("show")) {
        tipBar.classList.add("show");
        localStorage.setItem("loginTip", "1");
        setTimeout(function () {
          closeLoginTip();
        }, 15000)
      }
      if (isAndroid) {
        var hasDiff = tipBar.classList.contains("diff");
        if (hasDiff) {
          if (scrollTop < 56) {
            tipBar.classList.remove("diff");
          }
        } else {
          if (scrollTop >= 56) {
            tipBar.classList.add("diff");
          }
        }
      }
      if ((bodyHeight - scrollTop) < 1.3 * windowHeight) {
        tipBar.classList.remove("show");
      }
    }
  }
  function closeLoginTip() {
    needCheckLoginAutoTip = false;
    tipBar.classList.remove("show");
  }
  function onWindowScroll() {
    var docElement = document.documentElement;
    var docBody = document.body;
    var scrollTop = docElement.scrollTop || docBody.scrollTop;
    var bodyHeight = docBody.clientHeight;
    var windowHeight = window.innerHeight;
    var bodyTopEdge = document.body.getBoundingClientRect().top;

    if (bodyHeight > (3 * windowHeight) && newsId > 0 && newsInfoLoaded) {
      resetLoginTip(scrollTop, bodyHeight, windowHeight);
    }
    // 图片懒加载
    if (
      !isShareMode &&
      needAutoLoadImage &&
      !customLazyLoadFinished &&
      !useNativeLazyLoad
    ) {
      setTimeoutOnce(
        "lazyLoad",
        function () {
          var imgs = document.querySelectorAll("img[data-orignal]");
          if (imgs.length === 0 && newsInfoLoaded) {
            customLazyLoadFinished = true;
          }
          for (var i = 0; i < imgs.length; i++) {
            var img = imgs[i];
            var isLoading = img.classList.contains("loading");
            var realUrl = img.getAttribute("data-orignal");
            var isGif = img.classList.contains("gif");
            if (!isLoading && !(!needAutoLoadGif && isGif)) {
              if (realUrl && realUrl.length > 0) {
                var bound = img.getBoundingClientRect();
                if (scrollTop + 1.5 * windowHeight >= bound.top - bodyTopEdge) {
                  img.src = realUrl;
                  img.classList.add("loading");
                } else {
                  break;
                }
              } else {
                img.removeAttribute("data-orignal");
              }
            }
          }
        },
        50,
        200
      );
    }

    lastScrollY = scrollTop;
  }
  window.addEventListener("scroll", onWindowScroll);

  window.openItAccount = function () {
    if (itAccountId > 0 && !newsInfo.itaccount.closeAccountPage) {
      rm.vibrate();
      rm.navigateTo({
        url: "ithome://wmpage?id=" + itAccountId,
      });
    }
  };

  window.openAuthorPage = function () {
    if (newsInfo.user && newsInfo.user.userid) {
      rm.vibrate();
      rm.navigateTo({
        url: "ithome://userpage?id=" + newsInfo.user.userid + "&tab=article",
      });
    }
  };
  window.openErrorPick = function () {
    rm.vibrate();
    var intent = {
      newsId: newsId,
    };
    doAfterLogin(function () {
      rm.navigateTo({
        url: "https://img.ithome.com/app/errorfeedback/index.html?hidemenu=1",
        intent: intent,
      });
    }, "登录后纠错");
  };
  var lastSubmitCommentType = 0;
  var appReleaseArticleReg =
    /(辣品|云日历|IT之家|旗鱼浏览器)(安卓|iOS|微信小程序|小程序|UWP|macOS).+(发布|更新|上线|：)/;
  rm.onReceiveMessage("getCommentPlaceholder", function (data, callback) {
    var replyToComment =
      typeof data !== typeof undefined && data != null
        ? JSON.parse(data.replyToComment || "{}")
        : {};
    var isReplyFloor = replyToComment.Ci > 0;
    var reReplyToMainFloor =
      isReplyFloor && replyToComment.SF.indexOf("#") == -1;
    var resultHint = "文明发言，友善交流。";
    var userInfo = getUserInfo();
    var isToMe = userInfo.userid > 0 && userInfo.userid == replyToComment.Ui;
    var isM = userInfo.ism && userInfo.ism !== "false";
    var isN = userInfo.isn && userInfo.isn !== "false";
    var isC = userInfo.isc && userInfo.isc !== "false";
    var isE = userInfo.ise && userInfo.ise !== "false";
    var isRM = isE || isC || isM;
    var matchResult = newsInfo.title
      .replace(/ /g, "")
      .match(appReleaseArticleReg);
    var isAppReleaseNews = matchResult && matchResult.length > 1;
    var releaseAppName = isAppReleaseNews ? matchResult[1] : "";
    // var isIthomeReleaseNews = releaseAppName === "IT之家";
    if (!isReplyFloor) {
      // 主楼
      lastSubmitCommentType = 0;
      var hour = new Date().getHours();
      if (isAppReleaseNews && releaseAppName !== "辣品") {
        resultHint = "讲真的，IT之家真是越来越好用了呢~(*￣︶￣)".replace(
          "IT之家",
          releaseAppName
        );
      } else if (newsInfo.btheme) {
        resultHint = "敬畏生命，文明发言";
      } else if (hour >= 0 && hour <= 2) {
        resultHint = "Hi，{name}。夜深了，注意休息。".replace(
          "{name}",
          userInfo.nickname
        );
      }
    } else if (isToMe) {
      // 回复自己
      lastSubmitCommentType = 2;
      if (reReplyToMainFloor) {
        resultHint = "请输入要补充的内容~️";
      } else {
        resultHint = "emm...自言自语";
      }
    } else {
      // 回复别人
      lastSubmitCommentType = 1;
      if (
        isAppReleaseNews &&
        !isRM &&
        replyToComment.Ir &&
        replyToComment.M == 1
      ) {
        resultHint = "反馈问题？还请您尽可能详细描述~";
      } else if (!isRM && replyToComment.Ir && replyToComment.M == 1) {
        resultHint = "想对产品部帅哥/美女说...";
      } else if (!isRM && replyToComment.Ir && replyToComment.M == 2) {
        resultHint = "想对小编说...";
      } else if (
        rm.getSystemInfoSync().systemInfo &&
        rm.getSystemInfoSync().systemInfo.modelName == replyToComment.Ta
      ) {
        resultHint = "同是天涯好机友，相逢何必曾相识~";
      } else if (!isRM && isN) {
        resultHint = "文明交流，尊重他人，以身作则";
      }
    }

    callback({
      placeholder: resultHint,
    });
  });

  if (isIOS && typeof ResizeObserver !== "undefined") {
    var objResizeObserver = new ResizeObserver(function (entries) {
      rm.sendMessage({
        name: "bodySizeChanged",
        height: document.body.clientHeight,
        width: document.body.clientWidth,
      });
    });
    objResizeObserver.observe(document.body);
  }

  // 主题变化
  rm.onAppThemeChanged(function (status) {
    var isDark = status.isDark;
    var isAmoled = status.useAmoledBlack;
    if (isShareMode || isItPreviewMode) {
      isDark = false;
      isAmoled = false;
    }
    document.body.classList[isDark ? "add" : "remove"]("night");
    document.body.classList[isDark && isAmoled ? "add" : "remove"]("amoled");
  });

  // 文字大小、颜色等变化
  rm.onReceiveMessage("onFontSizeChanged", function (data) {
    setFontSize(data.fontSize);
  });

  // 获取文本内容
  rm.onReceiveMessage("onGetNewsText", function (data, callback) {
    callback(getNewsContent(data ? data.maxLength : 0));
  });

  // 页面可见性变化
  rm.onPageVisibleChanged(function (status) {
    // rm.toast({data: "visible:" + status.show})
    // if(status.show){
    //   var previewImgs = document.querySelectorAll(".in-preview");
    //   if(previewImgs.length > 0){
    //     for (var index = 0; index < previewImgs.length; index++) {
    //       var element = previewImgs[index];
    //       element.classList.remove("in-preview")
    //     }
    //   }
    // }
  });

  // 通知原生一切准备就绪
  rm.notifyNativeReady();

  // 监听宽度变化
  var windowWidth = window.innerWidth;
  var imageResizeTimer = 0;
  if (deviceModel.toLowerCase().indexOf("iPhone") === -1) {
    window.addEventListener("resize", function () {
      if (window.innerWidth !== windowWidth) {
        windowWidth = window.innerWidth;
        clearTimeout(imageResizeTimer);
        imageResizeTimer = setTimeout(function () {
          var allImages = content.querySelectorAll("img");
          for (var index = 0; index < allImages.length; index++) {
            var node = allImages[index];
            if (node.hasAttribute("w") && node.hasAttribute("h")) {
              var widthAttr = parseInt(node.getAttribute("w") || 0);
              var heightAttr = parseInt(node.getAttribute("h") || 1);
              var ratio = (widthAttr * 1.0) / heightAttr;
              var width = Math.min(widthAttr, getParagraphWidth());
              var height = parseInt(width / ratio);
              node.setAttribute("width", width);
              node.setAttribute("height", height);
            }
          }
          // rm.toast({ data: "已调整宽度6" });
        }, 120);
      }
    });
  }
});

function getNewsContent(maxLength) {
  var res = {
    title: h1.innerText,
  };
  var copyDom = document.createElement("div");
  copyDom.innerHTML = content.innerHTML;
  addEndForDoms(copyDom, "h2");
  addEndForDoms(copyDom, "h3");
  // remove doms
  removeAllElement(copyDom, "dir");
  removeAllElement(copyDom, "pre");
  removeAllElement(copyDom, "table");
  removeAllElement(copyDom, "iframe");
  removeAllElement(copyDom, "video");
  removeAllElement(copyDom, "p[id^=vote]");
  removeAllElement(copyDom, ".ithome_super_player");
  removeAllElement(copyDom, "figcaption")
  var contentStr = copyDom.innerText;
  var contents = [contentStr];
  if (maxLength && maxLength > 10 && contentStr.length > maxLength) {
    contents = [];
    var lines = splitWords(contentStr, ["。", "！", "？", "……", "；", "："]);
    var tempStr = "";
    lines.forEach(function (line) {
      if (!isEmpty(tempStr) && (tempStr + line).length > maxLength) {
        contents.push(tempStr);
        tempStr = line;
      } else {
        tempStr += line;
      }
    });
    if (!isEmpty(tempStr)) {
      contents.push(tempStr);
    }
  }
  res.contents = contents;
  return res;
}

function splitWords(contentStr, words) {
  var res = [contentStr];
  words.forEach(function (word) {
    res = splitWord(res, word);
  });
  return res;
}
function splitWord(contents, word) {
  var res = [];
  contents.forEach(function (str, j) {
    var lines = str.split(word);
    lines.forEach(function (seg, index) {
      if (index !== lines.length - 1) {
        lines[index] = seg + word;
      }
    });
    res = res.concat(lines);
  });
  return res;
}
function addEndForDoms(targetDom, selector) {
  var doms = targetDom.querySelectorAll(selector);
  for (var i = 0; i < doms.length; i++) {
    var dom = doms[i];
    if (dom) dom.innerHTML = dom.innerHTML + "。";
  }
}
function removeAllElement(targetDom, selector) {
  var doms = targetDom.querySelectorAll(selector);
  for (var i = 0; i < doms.length; i++) {
    var dom = doms[i];
    if (dom) dom.remove();
  }
}
function isBirthNews() {
  return newsInfo.id === parseInt(config.cloud.bitrhid || "0");
}
function setFontSize(newSize) {
  newSize = !isEmpty(newSize) ? newSize : null;
  if (fontSize !== newSize) {
    if (fontSize) {
      document.documentElement.classList.remove("font-size-" + fontSize);
    }
    fontSize = newSize;
    if (newSize) {
      document.documentElement.classList.add("font-size-" + newSize);
      localStorage.setItem("fontSize", newSize);
    } else {
      localStorage.removeItem("fontSize");
    }
  }
}

function resizerPatchfunction() {
  clearTimeout(resizeTimer);
  resizeTimer = setTimeout(function () {
    NestedWebViewApi && NestedWebViewApi.onResize();
  }, 200);
}


function checkTable(node) {
  var tableList = node.querySelectorAll("table");
  hasTable = tableList.length > 0;
  if (hasTable) {
    for (var i = 0; i < tableList.length; i++) {
      var e = tableList[i];
      var p = document.createElement("div");
      p.className = "tableDiv";
      p.innerHTML = e.outerHTML;
      e.parentNode.replaceChild(p, e);
    }
  }
}

function dealWithShareMode() {
  window._shareImgMaxHeight = 10000;
  if (isShareMode) {
    var currentProgress = 0;
    var isIos = rm.getEnv().platform === "iOS";

    // 处理图片
    var imgs = content.querySelectorAll("img");
    if (imgs.length === 0) {
      rm.sendMessage({
        name: "shareProcessProgress",
        progress: 100,
        text1: "长按识别二维码阅读原文",
        text2: "即时科技资讯尽在IT之家",
        maxHeight: window._shareImgMaxHeight,
        showComment: false,
      });
    } else {
      // checkReady();
      for (var index = 0; index < imgs.length; index++) {
        var element = imgs[index];
        // var realSrc = getRealSrc(element);
        var hasOriginal = !isEmpty(getRealSrc(element));
        var realUrlIsSet =
          !hasOriginal || getRealSrc(element) === element.getAttribute("src");
        if (!realUrlIsSet) {
          element.setAttribute("src", getRealSrc(element));
        } else {
          element.classList.add("skip");
        }
      }
      setTimeout(function () {
        checkReady();
        if (isIos && content.clientHeight > window._shareImgMaxHeight) {
          content.style.maxHeight = window._shareImgMaxHeight + "px";
          content.insertAdjacentHTML(
            "beforeend",
            "<div class='share_end'><div class='share_end_musk'></div><div class='share_end_tip'>下载IT之家App查看原文</div></div>"
          );
        }
      }, 80);
      var timer = setInterval(function () {
        checkReady();
      }, 150);
    }

    function checkReady() {
      var allImgs = content.querySelectorAll("img");
      var imgsNotReady = [];
      for (var index = 0; index < allImgs.length; index++) {
        var element = allImgs[index];
        var hasOriginal = !isEmpty(getRealSrc(element));
        var realUrlIsSet =
          !hasOriginal || getRealSrc(element) === element.getAttribute("src");
        var imgLoaded =
          element.classList.contains("loaded") ||
          element.classList.contains("skip") ||
          element.classList.contains("error");
        var complete = realUrlIsSet && imgLoaded;
        if (!complete) {
          imgsNotReady.push(element);
        }
      }

      var progress = parseFloat(
        (allImgs.length === 0
          ? 100
          : (1 - (imgsNotReady.length * 1.0) / allImgs.length) * 100
        ).toFixed(0)
      );
      if (progress !== currentProgress) {
        currentProgress = progress;
        setTimeout(function () {
          rm.sendMessage({
            name: "shareProcessProgress",
            progress: progress,
            text1: "长按识别二维码阅读原文",
            text2: "即时科技资讯尽在IT之家",
            maxHeight: window._shareImgMaxHeight,
            showComment: false,
          });
        }, 100);
      }
      if (progress > 99.999999999) {
        clearInterval(timer);
      }
    }
  }
}

function clickFeedback() {
  setTimeout(function () {
    var model = rm.getSystemInfoSync().systemInfo.model || "";
    var myosType = "android";
    if (rm.getEnv().platform === "Android") {
      myosType = "android";
    } else if (model.toLowerCase().indexOf("ipad") !== -1) {
      myosType = "ipad";
    } else {
      myosType = "iphone";
    }
    var url = Api("https://dyn.ithome.com/ithome/hitcount.aspx", {
      newsid: newsId,
      dev: myosType,
    });
    rm.request(
      {
        url: url,
      },
      function (res) { }
    );
  }, 50);
}

function loadViewCount(initCount) {
  if (getUserInfo().isc === "true" || getUserInfo().ism === "true" || getUserInfo().userid === 47) {
    setTimeout(function () {
      var dom = null;
      if (itAccountId > 0) {
        dom = document.querySelectorAll(".viewcount_value")[1];
        if (dom) dom.innerText = initCount + "阅";
      } else {
        dom = document.querySelectorAll(".viewcount_value")[0];
        if (dom) dom.innerText = initCount;
      }
      var api = Api("https://dyn.ithome.com/json/newscount", {
        userHash: getUserHash(),
        sid: rm.encryptSync({ text: newsId + "" }).data,
      });
      if (dom) {
        rm.request(
          {
            url: api,
          },
          function (res) {
            if (res.data && res.data.content) {
              var count = res.data.content.hitcount || 0;
              if (itAccountId > 0) {
                dom.innerText = count + "阅";
              } else {
                dom.innerText = count;
              }
              document.querySelector(".viewcount_value").innerText =
                res.data.content.hitcount || 0;
            }
          }
        );
      }
    }, 0);
  }
}

////////////////////////////////////////
///////////                //////////////
//////////       工具      /////////////
//////////                 /////////////
////////////////////////////////////////
function removeWebpParam(url) {
  var res = url.replace("/format,f_auto", "");
  if (__parseUrl(res).params["x-bce-process"] === "image") {
    res = res
      .replace("?x-bce-process=image", "")
      .replace("&x-bce-process=image", "");
  }
  return res;
}

function getPlatformUrl(aTag) {
  var attrs = ["href"];
  var platform = rm.getEnv().platform
  if (rm.isLegalEnv()) {

    switch (platform) {
      case "iOS":
        attrs.push("data-appurl");
        attrs.push("data-iosurl");
        break;
      case "Android":
        attrs.push("data-appurl");
        attrs.push("data-androidurl");
        break;
      case "UWP":
        attrs.push("data-appurl");
        attrs.push("data-uwpurl");
        break;
    }
    if (rm.getEnv().isHM) {
      attrs.push("data-hosurl");
    }
    var openFrom = config.openFrom;
    if (openFrom) {
      var openFromInfo = __parseUrl(openFrom);
      if (openFromInfo.scheme === "ithome" && openFromInfo.params.from) {
        if (openFromInfo.params.from === "ithomewx") {
          attrs.push("data-itwxurl");
        } else if (openFromInfo.params.from === "lapinwx") {
          attrs.push("data-lpwxurl");
        }
      }
    }
  } else {
    switch (platform) {
      case "iOS":
      case "Android":
        attrs.push("data-wapurl");
        break;
    }
  }
  attrs.reverse();
  var url = "";
  var resAttr = "";
  while (isEmpty(url) && attrs.length > 0) {
    url = aTag.getAttribute(attrs[0]);
    resAttr = attrs[0];
    attrs.splice(0, 1);
  }
  console.log("choose ling attr:" + resAttr);
  return url;
}

function getUserInfo() {
  return rm.getUserInfoSync().userInfo || {};
}

function getUserId() {
  return (rm.getUserInfoSync().userInfo || {}).userid;
}

function isLogin() {
  return getUserId() > 0;
}

function getUserHash() {
  return rm.getUserHashSync().userHash || "";
}

function toast(str) {
  rm.toast({
    data: str,
  });
}

function doAfterLogin(func, fallback, tips) {
  rm.login(function (res) {
    if (res.success) {
      if (func)
        func();
    } else {
      if (typeof fallback === "function") {
        fallback();
      } else if (!isEmpty(tips))
        rm.toast({
          data: tips,
        });
    }
  });
}
function getAvatarAddress(e, t) {
  for (var r = e + ""; r.length < 9;) r = "0" + r;
  var n = r.substring(0, 3),
    a = r.substring(3, 5),
    i = r.substring(5, 7),
    s = r.substring(7, 9),
    o =
      "https://avatar.ithome.com/avatars/" +
      n +
      "/" +
      a +
      "/" +
      i +
      "/" +
      s +
      "_60.jpg";
  return (
    t &&
    (o =
      "https://my.ruanmei.com/images/upload/avatars/" +
      n +
      "/" +
      a +
      "/" +
      i +
      "/" +
      s +
      "_avatar.jpg"),
    o
  );
}
function getNewsUrl(item) {
  var idStr = item.newsid + "";
  while (idStr.length < 7) {
    idStr = "0" + idStr;
  }
  var url =
    "https://www.ithome.com/" +
    idStr.substring(0, 1) +
    "/" +
    idStr.substring(1, 4) +
    "/" +
    idStr.substring(4) +
    ".htm";
  var slink = "ithome://news?id=" + item.newsid + "&type=news&_newtask=1";
  if (item.live) {
    url = "https://live.ithome.com/item/" + item.newsid + ".htm";
    slink = "ithome://news?id=" + item.newsid + "&type=live&_newtask=1";
  } else if (item.sid) {
    url = item.url;
    slink = "ithome://newstopic?id=" + item.sid + "&_newtask=1";
  }
  if (url.indexOf("http") === -1) {
    url = "https://www.ithome.com" + url;
  }
  return {
    url: url,
    slink: slink,
  };
}
function isClickIn(filter, e) {
  var target = e.target;
  var fireEvent = false;
  while (!fireEvent && !!target && target !== e.currentTarget) {
    if (filter(target)) {
      fireEvent = true;
      break;
    }
    target = target.parentElement || target.parentNode;
  }
  return fireEvent;
}

function isIn(target, filter) {
  var fireEvent = false;
  while (!fireEvent && !!target && target !== document.body) {
    if (filter(target)) {
      fireEvent = true;
      break;
    }
    target = target.parentElement || target.parentNode;
  }
  return fireEvent;
}

function findParent(node, filterFn, includeSelf) {
  if (node && !isBody(node)) {
    node = includeSelf ? node : node.parentNode;
    while (node) {
      if (!filterFn || filterFn(node) || isBody(node)) {
        return filterFn && !filterFn(node) && isBody(node) ? null : node;
      }
      node = node.parentNode;
    }
  }
  return null;
}

function findParentByTagName(node, tagNames, includeSelf, excludeFn) {
  tagNames = listToMap(Array.isArray(tagNames) ? tagNames : [tagNames]);
  return findParent(
    node,
    function (node) {
      return tagNames[node.tagName] && !(excludeFn && excludeFn(node));
    },
    includeSelf
  );
}

function listToMap(list) {
  if (!list) return {};
  list = Array.isArray(list) ? list : list.split(",");
  for (var i = 0, ci, obj = {}; (ci = list[i++]);) {
    obj[ci.toUpperCase()] = obj[ci] = 1;
  }
  return obj;
}
function uuid() {
  var s = [];
  var hexDigits = "0123456789abcdef";
  for (var i = 0; i < 36; i++) {
    s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
  }
  s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
  s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
  s[8] = s[13] = s[18] = s[23] = "-";

  var uuid = s.join("");
  return uuid;
}
function isBody(node) {
  return node.tagName === "BODY";
}
function isEmpty(e) {
  return void 0 === e || null == e || 0 == e.length;
}
function getDateFromString(e) {
  var t = e;
  return isEmpty(t)
    ? new Date()
    : "number" == typeof t
      ? new Date(t)
      : (-1 != t.indexOf("/Date(")
        ? ((t = t.replace("/Date(", "").replace(")/", "")), (t = parseInt(t)))
        : t.indexOf("T") > 0 &&
        (t.lastIndexOf(".") > 0 && (t = t.substring(0, t.lastIndexOf("."))),
          -1 == t.indexOf("+") && -1 == t.indexOf("Z") && (t += "+08:00")),
        new Date(t));
}

function pad(e, t) {
  for (var r = e.toString().length; r < t;) (e = "0" + e), r++;
  return e;
}
function Api(url, params) {
  var result = url;
  if (params) {
    Object.keys(params).forEach(function (key) {
      var value = encodeURIComponent(params[key]);
      if (result.indexOf("{" + key.toLowerCase() + "}") !== -1) {
        result = result.replace("{" + key.toLowerCase() + "}", value);
      } else {
        var keyValue = key + "=" + value;
        result += (result.indexOf("?") !== -1 ? "&" : "?") + keyValue;
      }
    });
  }
  return result;
}
function highlightKeyWords(node, keywords) {
  var list = keywords.slice(0);
  list.forEach(function (item) {
    var patterns = hanldeKeyword([item.key]);
    highlightKeyword(node, patterns[0], item);
  });
}
function hanldeKeyword(keywords) {
  var wordMatchString = "";
  var words = keywords.slice(0);
  words.forEach(function (item) {
    var transformString = item.replace(/[.[*?+^$|()/]|\]|\\/g, "\\$&");
    wordMatchString += "|(" + transformString + ")";
  });
  wordMatchString = wordMatchString.substring(1);
  // 用于再次高亮与关闭的关键字作为一个整体的匹配正则
  var wholePattern = new RegExp("^" + wordMatchString + "$");
  // 用于第一次高亮的关键字匹配正则
  var pattern = new RegExp(wordMatchString);
  return [pattern, wholePattern];
}
function highlightKeyword(node, pattern, errorInfo, index) {
  var exposeCount = 0;
  if (node.nodeType === Node.TEXT_NODE) {
    var matchResult = node.data.match(pattern);
    if (matchResult) {
      var highlightEl = document.createElement("span");
      highlightEl.dataset.highlight = "quote";
      index == null || (highlightEl.dataset.highlightIndex = index + "");
      var initOffset = matchResult.index;
      var matchNode = node.splitText(
        errorInfo.singleindex === -1
          ? initOffset
          : initOffset + errorInfo.singleindex
      );
      matchNode.splitText(
        errorInfo.singleindex === -1 ? matchResult[0].length : 1
      );

      var highlightTextNode = document.createTextNode(matchNode.data);
      highlightEl.appendChild(highlightTextNode);
      matchNode.parentNode.replaceChild(highlightEl, matchNode);
      exposeCount++;
    }
  } else if (
    node.nodeType === 1 &&
    !/script|style/.test(node.tagName.toLowerCase())
  ) {
    if (node.dataset.highlight === "quote") {
      if (index == null) {
        return;
      }
      if (node.dataset.highlightIndex === index + "") {
        return;
      }
    }
    var childNodes = node.childNodes;
    for (var i = 0; i < childNodes.length; i++) {
      highlightKeyword(childNodes[i], pattern, errorInfo, index);
    }
  }
  return exposeCount;
}
function normalizeNode(node) {
  var parentNode = node.parentNode;
  var childNodes = node.childNodes;
  var childNodesLen = childNodes.length;
  var nextSibling = node.nextSibling;
  if (parentNode) {
    for (var k = 0; k < childNodesLen; k++) {
      parentNode.insertBefore(childNodes[0], nextSibling);
    }
    var flagNode = document.createTextNode("");
    parentNode.replaceChild(flagNode, node);
    parentNode.normalize();
  }
}
function getBilibiliUrlInfo(u) {
  var url = u;
  if (!isEmpty(url) && url.indexOf("bilibili") !== -1) {
    // 视频
    -1 !== url.indexOf("?") && (url = url.substring(0, url.indexOf("?")));
    -1 !== url.indexOf("#") && (url = url.substring(0, url.indexOf("#")));
    if (url.substring(url.length - 1) === "/") {
      url = url.substring(0, url.length - 1);
    }

    var bilibiliAvReg = /bilibili\.com.*?\/av(\d+)/i;
    var matchResult = url.match(bilibiliAvReg);
    var bilibiliBvReg = /bilibili\.com.*?\/BV([^\/\?\#]+)/i;
    var matchBvResult = url.match(bilibiliBvReg);
    var bilibiliLiveReg = /live.bilibili.co.+\/(\d+)/;
    var matchLiveResult = url.match(bilibiliLiveReg);
    var accountReg = /space.bilibili.com\/(\d+)/;
    var matchAccountResult = url.match(accountReg);

    if (matchResult && matchResult.length == 2) {
      var avNum = matchResult[1];
      return { avid: avNum, scheme: "bilibili://video/" + avNum };
    } else if (matchBvResult && matchBvResult.length == 2) {
      var bvNum = matchBvResult[1];
      if (bvNum.toLowerCase().indexOf("bv") !== 0) {
        //修正BV号
        bvNum = "bv" + bvNum;
      }
      return { bvid: bvNum, scheme: "bilibili://video/" + bvNum };
    } else if (matchLiveResult && matchLiveResult.length == 2) {
      var roomId = matchLiveResult[1];
      return { liveid: roomId, scheme: "bilibili://live/" + roomId };
    } else if (matchAccountResult && matchAccountResult.length == 2) {
      var accountId = matchAccountResult[1];
      return { spaceid: accountId, scheme: "bilibili://space/" + accountId };
    }
  }
  return {};
}
function __parseUrl(n) {
  var e = n.split("://"),
    i = e[0],
    s = e[1];
  -1 != s.indexOf("/") && (s = s.split("/")[0]),
    -1 !== s.indexOf("?") && (s = s.substring(0, s.indexOf("?"))),
    -1 !== s.indexOf("#") && (s = s.substring(0, s.indexOf("#")));
  var r = {},
    t = "",
    d = "",
    f = n.substring(n.indexOf("?") + 1, n.length).split("&");
  for (var x in f) {
    var O = f[x];
    O.indexOf("=") > 0 &&
      ((t = O.substring(0, O.indexOf("="))),
        (d = O.substring(O.indexOf("=") + 1)),
        -1 !== d.indexOf("#") && (d = d.substring(0, d.indexOf("#"))),
        (r[t] = decodeURIComponent(d)));
  }
  return { scheme: i.toLowerCase(), host: s.toLowerCase(), params: r };
}
function setTimeoutOnce(timerKey, task, delay, maxInterval) {
  if (
    Math.abs(
      new Date().getTime() - ((window["lastExeTimeFor"] || {})[timerKey] || 0)
    ) > (maxInterval || delay)
  ) {
    if (!window["lastExeTimeFor"]) {
      window["lastExeTimeFor"] = {};
    }
    window["lastExeTimeFor"][timerKey] = new Date().getTime();
    task();
  }
  clearTimeout(window[timerKey] || 0);
  window[timerKey] = setTimeout(function () {
    if (!window["lastExeTimeFor"]) {
      window["lastExeTimeFor"] = {};
    }
    window["lastExeTimeFor"][timerKey] = new Date().getTime();
    task();
  }, delay);
}

function clearTimeoutOnce(timerKey) {
  clearTimeout(window[timerKey] || 0);
}
function getRealSrc(element, useProxy) {
  if (useProxy && !isEmpty(element.getAttribute("data-proxy"))) {
    return element.getAttribute("data-proxy");
  }
  if (!isEmpty(element.getAttribute("data-orignal"))) {
    return element.getAttribute("data-orignal");
  }
  if (!isEmpty(element.getAttribute("src"))) {
    return element.getAttribute("src");
  }
  return null;
}

function forEachNode(container, query, callback) {
  var all = container.querySelectorAll(query);
  for (var i = 0; i < all.length; i++) {
    var dom = all[i];
    callback(dom);
  }
}
function _checkSwipeGesture(touchYDP) {
  var allIframeElement = content.getElementsByTagName("iframe");
  var allPreElement = content.getElementsByTagName("pre");
  var allVideoElement = content.getElementsByTagName("video");
  var allTableDiv = content.getElementsByClassName("tableDiv");
  var allPreBars = content.getElementsByClassName("pre-bar");
  var canSwipe =
    checkIfNotInElements(allIframeElement, touchYDP) && //不在iframe内
    checkIfNotInElements(allPreElement, touchYDP) && //不在pre代码块内
    checkIfNotInElements(allVideoElement, touchYDP) && //不在video内
    checkIfNotInElements(allTableDiv, touchYDP) && //不在tableDiv内
    checkIfNotInElements(allPreBars, touchYDP); //不在Pre bar内
  return canSwipe;
}

function checkIfInElement(anchor, touchYDP) {
  var rect = anchor.getBoundingClientRect();
  var top = rect.top;
  var bottom = rect.bottom;
  return touchYDP >= top - 6 && touchYDP <= bottom + 6;
}

function checkIfNotInElements(elements, touchYDP) {
  var alenght = elements.length;
  var notIn = true;
  if (alenght > 0) {
    for (var i = 0; i < alenght; i++) {
      var anchor = elements[i];
      if (checkIfInElement(anchor, touchYDP)) {
        notIn = false;
      }
    }
  }
  return notIn;
}
function getSwitchByPosition(flags, position) {
  if (position < 0) {
    return false;
  }
  // eslint-disable-next-line no-bitwise
  return (flags & Math.pow(2, position)) > 0;
}
function initFireworks() {
  if (!fireworks) {
    fireworks = new Fireworks();
    fireworks.init()
  }
}
function releaseFireworks() {
  if (fireworks) {
    fireworks.release();
    fireworks = null;
  }
}

/**
 * 图片加载成功事件
 * @param {HTMLImageElement} img 
 */
function onImgLoaded(img) {
  // console.log("onImgLoaded", img.getAttribute("src"));
  if (!isShareMode) {
    if (img.getAttribute("src") !== "imgs/transparent.png") {
      img.classList.remove("loading");
      img.classList.add("loaded");
      img.removeAttribute("data-orignal");
      checkImageProxyLoad(img);
    }
  } else {
    img.classList.add("loaded");
  }
}

var proxyLoadingClass = "proxy-loading";
var proxyLoadedClass = "proxy-loaded";
var proxyErrorClass = "proxy-error";

function checkImageProxyLoad(img) {
  var isProxy = img.getAttribute("src") === "imgs/proxy.png";
  if (isProxy) {
    if (!img.classList.contains(proxyLoadingClass)) {
      img.classList.add(proxyLoadingClass);
      proxyLoad({
        success: function (url) {
          img.setAttribute("src", url);
          img.classList.add(proxyLoadedClass);
          img.classList.remove(proxyLoadingClass);
        },
        error: function (error) {
          img.classList.add(proxyErrorClass);
          img.classList.remove(proxyLoadingClass);
        }
      })
    }
  } else {
    img.classList.remove(proxyLoadingClass);
    img.classList.remove(proxyErrorClass);
  }

  function proxyLoad(cb) {
    if (isAndroid) {
      var image = document.createElement("img");
      image.onload = function () {
        cb.success(image.getAttribute("src"))
      }
      image.onerror = function () {
        cb.error()
      }
      console.log("proxyLoad", img.getAttribute("data-proxy"))
      image.src = img.getAttribute("data-proxy");
    } else {
      rm.sendMessage({
        name: "requestInterceptImageLoad",  //固定值
        data: {
          url: img.getAttribute("data-proxy"),
          acceptWebp: true,
          acceptHeic: true
        }
      }, function (res) {
        if (res && res.url) {
          cb.success(res.url)
        } else {
          cb.error()
        }
      });
    }


  }

  return isProxy;
}

/**
 * 图片加载失败事件
 * @param {HTMLImageElement} img 
 */
function onImgError(img) {
  // console.log("onImageError", img.getAttribute("src"));
  if (!isShareMode) {
    if (img.hasAttribute("data-orignal")) {
      img.removeAttribute("src");
    }
    img.classList.remove("loading");
    img.classList.remove(proxyLoadingClass);
  } else {
    img.classList.add("error");
  }
}